 // laplace = recursief =>  eerst enkele oef recursie
// Oef 1 = programmeer macht(grondtal, exponent)
// Eerst lus daarna recursief
// Vb macht(2,7) => 128
function r = macht(grondtal, exponent)
    if exponent < 0 then
        error('Geen negatieve exponenten')
    end
    
    r = 1
    
    for i = 1:exponent
        r = r*grondtal
    end
endfunction

function r = machtrec(grondtal, exponent)
    if exponent == 0
        r = 1
    else
        r = grondtal * machtrec(grondtal, exponent - 1)
    end
endfunction

// Oef 2: programmeer op twee manieren (iteratie + recursie) de facculteit
// vb 6! = 6*5*4*3*2*1

function r = fac(getal)
    r = 1
    
    for i = 1:getal
        r = r * i
    end
endfunction

function r = facrec(getal)
    if getal == 0 then
        r = 1
    else
        r = getal * facrec(getal - 1)
    end
endfunction

// Methode van laplace om determinanten te berekenen
// Hulp functie om rijen en kolomen te schrappen
function N = schrap(M, rij, kol)
    // schrap in M de rij rij en kolom kol
    // zet het resultaat in nieuwe matrix N
    N = M
    
    N(rij,:) = []
    N(:,kol) = []
endfunction

function d = laplace(M)
    [arij akol] = size(M)
    
    if arij ~= akol then
        error('Matrix is niet vierkant')
    end
    
    if arij == 1 then
        d = M(1,1)
    else
        d = 0
        
        for j = 1:arij
            d = d + (-1)^(1+j)*M(1,j)*laplace(schrap(M,1,j))
        end
        
    end
endfunction

B = [-4  2 6  8
      1  3 5  2
      9 -4 5  6
      7  1 5 -5]

function tijd = testdet(M)
    tic()
    dummy = laplace(M)
    tijd = toc()
endfunction














